class motor
{
  private:
    uint32_t long_pulse_tick; // Длина импульса в тиках
    uint8_t CHANNEL; //Номер канала PWM
    uint8_t resolution; // Разрешение
    double frequency; //Частота канала PWM
    unsigned long control_time = 0; //Контролируем время между изменениями значений - для наших моторов меньше чем 50
  public:
    uint32_t long_pulse_usec; // Длина импульса в микросекундах
    int pwm_pin, dir_pin, break_pin;
    bool dir_q = false;
    bool break_q = false;
    motor(uint8_t Ch, int pwm, int dir, int breakp, double frec = 1000, uint8_t Res = 16, uint32_t MIN_P = 655, uint32_t MAX_P = 58900)
    {
      pwm_pin = pwm; dir_pin = dir; break_pin = breakp;
      min_pulse = MIN_P; //Лимиты длины импульсов
      max_pulse = MAX_P;
      if (Ch > 15) Ch = 15;
      CHANNEL = Ch; resolution = Res;
      if (frec >= 50.0 && (frec <= 10000.0)) frequency = frec; else frequency = 50.0; //Настройка частоты, для хороших драйверов верхний предел можно увеличить
      ledcSetup(CHANNEL, frequency, resolution);
      ledcAttachPin(pwm_pin, CHANNEL);
      pinMode(pwm_pin, OUTPUT);
      pinMode(dir_pin, OUTPUT);
      pinMode(break_pin, OUTPUT);
      ledcWrite(CHANNEL, min_pulse);
      dir_q = false;
      digitalWrite(dir_pin, dir_q);
      break_q = false;
      digitalWrite(break_pin, break_q);
    };

    bool motorPWM_pulse(double LPU) //Ширина импульса в %
    {
      unsigned long tec_time;
      tec_time = millis();
      if (tec_time < control_time) return false; // Для моих драйверов возможно изменение не чаще 50 милисек.
      control_time = tec_time + 50;
      uint32_t old_pulse = long_pulse_usec;
      uint32_t n_long_pulse_usec = uint32_t(double(min_pulse) + double(max_pulse - min_pulse) * LPU) ;
      if (n_long_pulse_usec < min_pulse)  long_pulse_usec = min_pulse;
      else if (n_long_pulse_usec > max_pulse)long_pulse_usec = max_pulse;
      else long_pulse_usec = n_long_pulse_usec;
      if (old_pulse != long_pulse_usec)
      {
        long_pulse_tick = long_pulse_usec;
        ledcWrite(CHANNEL, long_pulse_tick);
        Serial.println(long_pulse_tick);
        return true;
      }
      return false;
    };
    bool motorPWM_pulse_D(int32_t DLPU) //Изменение Длины импульса в микрсек
    {
      int32_t new_pulse ;
      new_pulse =  long_pulse_usec;
      new_pulse += DLPU;
      motorPWM_pulse(uint32_t(new_pulse));
    }
    uint32_t min_pulse; // минимальная Длина импульса с микросек
    uint32_t max_pulse; // максимальная Длина импульса с микросек

    void motor_DIR(bool Naravlenye) //
    {
      dir_q = Naravlenye;
      digitalWrite(dir_pin, dir_q);
    }
    void motor_BreAK(bool br) //
    {
      break_q = br;
      digitalWrite(break_pin, break_q);
    }
};
//Пришлось убрать из использования D12 т.к. он должен быть в 0 при загрузке, а при использовании двунаправленного конвертора уровней на него может быть подано напряжение.
